function [UniSt,UniSt2_1,UniSt2_2,ProbSt,GammaSt,DeltaSt1,DeltaSt2,loglik,probprec,prigam,pridel1,pridel2,Beta01matSt,Beta02matSt,storeADgam,...
    storeSgam,storeADdel1,storeADdel2,storeSdel1,storeSdel2,acceptgam,acceptdelta1,acceptdelta2,acceptBeta1,acceptBeta2,Avet,B1vet,B2vet,C,D1vet,D2vet,NaccB]= ...
metrofMRI2(X,Y1,Y2,Z,gamprec,deltaprec1,deltaprec2,loglik,probprec,prigam,pridel1,pridel2,Beta01prec,Beta02prec,pPar,eta,mu,pd,ak,...
bk,Phi,delW,aj,bj,n1,n2,p,q,MRF,acceptgam,acceptdelta1,acceptdelta2,acceptBeta1,acceptBeta2,nPar,Avet,B1vet,B2vet,C,D1vet,D2vet,NaccB,h,h1)

storeADgam=[]; storeSgam=[];
storeADdel1=[]; storeSdel1=[];
storeADdel2=[]; storeSdel2=[];

GammaSt = cell(nPar,1); DeltaSt1 = cell(nPar,1); DeltaSt2 = cell(nPar,1);
ProbSt = zeros(1,nPar); UniSt = zeros(1,nPar); UniSt2_1=zeros(1,nPar); UniSt2_2=zeros(1,nPar);
Beta01matSt = zeros(p,nPar); Beta02matSt = zeros(p,nPar);

%%%%%% M-H step for $\gamma$
for i=1:nPar
    gamnew = gamprec; poszeros = find(gamprec==0);
    if length(poszeros)==p           % Forced to add variable
        chi='ADgam';
        choice=ceil(rand(1)*p);
        if choice==0
            choice=1;
        else
        end
        gamnew(choice)=1;        
        [Cnew,prigamnew] = mmlfMRIgam2(gamnew,Phi,Beta01prec,Beta02prec,delW,MRF,mu,eta,h1);
        Adiff = -Avet(choice); Ddiff = -D1vet(choice)-D2vet(choice);
        [B1vetnew,B2vetnew] = mmlfMRIdelUno(deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,ak,bk,choice,h);
        B1vet(choice) = B1vetnew; B2vet(choice) = B2vetnew;
        Bdiff = B1vetnew+B2vetnew;
    elseif  isempty(poszeros)         % Forced to delete variable
        chi='ADgam';
        choice=ceil(rand(1)*p);
        if choice==0
            choice=1;
        else
        end
        gamnew(choice)=0;
        [Cnew,prigamnew] = mmlfMRIgam2(gamnew,Phi,Beta01prec,Beta02prec,delW,MRF,mu,eta,h1);
        Adiff = Avet(choice);  Bdiff = -B1vet(choice)-B2vet(choice);
        Ddiff = D1vet(choice)+D2vet(choice);
    else            
        x=rand(1);
        if x<pPar
%-------------------Adding/Deleting
            chi='ADgam';
            choice=ceil(rand(1)*p);
            if choice==0
                choice=1;
            else
            end
            gamnew(choice) = abs(gamnew(choice)-1);            
            [Cnew,prigamnew] = mmlfMRIgam2(gamnew,Phi,Beta01prec,Beta02prec,delW,MRF,mu,eta,h1);
            if (gamnew(choice)-1)==0
                Adiff = -Avet(choice); Ddiff = -D1vet(choice)-D2vet(choice);
                [B1vetnew,B2vetnew] = mmlfMRIdelUno(deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,ak,bk,choice,h);
                B1vet(choice) = B1vetnew; B2vet(choice) = B2vetnew;
                Bdiff = B1vetnew+B2vetnew;
            else
                Adiff = Avet(choice);  Bdiff = -B1vet(choice)-B2vet(choice);
                Ddiff = D1vet(choice)+D2vet(choice);
            end
        else
%-------------------Swapping
            chi='Sgam';
            poszeros = find(gamprec==0);
            posones = find(gamprec==1);
            choice1=ceil(rand(1)*length(poszeros));
            if choice1==0
                choice1 = 1;
            else
            end
            choice2 = ceil(rand(1)*length(posones));
            if choice1==0
                choice1 = 1;
            else
            end
            elem1=poszeros(choice1);    
            elem2=posones(choice2);     
            gamnew(elem1)=1;            
            gamnew(elem2)=0;            
            [Cnew,prigamnew] = mmlfMRIgam2(gamnew,Phi,Beta01prec,Beta02prec,delW,MRF,mu,eta,h1);
            [B1vetnew,B2vetnew] = mmlfMRIdelUno(deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,ak,bk,elem1,h);
            B1vet(elem1) = B1vetnew; B2vet(elem1) = B2vetnew;
            Adiff = Avet(elem2)-Avet(elem1); Bdiff = B1vet(elem1)+B2vet(elem1)-B1vet(elem2)-B2vet(elem2);
            Ddiff = D1vet(elem2)+D2vet(elem2)-D1vet(elem1)-D2vet(elem1);
        end
    end
              
    move=min(0, Adiff+Bdiff+Ddiff+Cnew-C+prigamnew-prigam );
    if move==0
        gamprec = gamnew;     
        eval(['store',chi,'=[store',chi,' i];'])        
        loglik = Cnew + sum(Avet(logical(gamprec==0)))+sum(B1vet(logical(gamprec)))+sum(B2vet(logical(gamprec)))+sum(D1vet(logical(gamprec==0)))+...
        sum(D2vet(logical(gamprec==0)));
        probprec = loglik+prigamnew+pridel1+pridel2;                
        GammaSt{i} = num2str(find(gamnew));
        UniSt(i) = length(find(gamnew)); 
       	acceptgam = acceptgam+1;        
        prigam = prigamnew;
        C = Cnew;
    else if (rand(1) < exp(move))
            gamprec = gamnew;     
            eval(['store',chi,'=[store',chi,' i];'])        
            loglik = Cnew + sum(Avet(logical(gamprec==0)))+sum(B1vet(logical(gamprec)))+sum(B2vet(logical(gamprec)))+sum(D1vet(logical(gamprec==0)))+...
            sum(D2vet(logical(gamprec==0)));
            probprec = loglik+prigamnew+pridel1+pridel2;
            GammaSt{i} = num2str(find(gamnew));
            UniSt(i) = length(find(gamnew)); 
            acceptgam = acceptgam+1;        
            prigam = prigamnew;
            C = Cnew;
        else
            GammaSt{i}=num2str(find(gamprec));
            UniSt(i)=length(find(gamprec));           
        end
    end

%%%%%% M-H step for $\delta_1$
    deltanew1 = deltaprec1; poszeros = find(deltaprec1==0); varSel =sum(gamprec);
    if isempty(poszeros)
    else        
        if length(poszeros)==q          % Forced to add variable
            chi='ADdel1';
            choice=ceil(rand(1)*q);
            if choice==0
                choice=1;
            else
            end
            deltanew1(choice) = 1;        
            [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltanew1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
        elseif  isempty(poszeros)       % Forced to delete variable
            chi='ADdel1';
            choice=ceil(rand(1)*q);
            if choice==0
                choice=1;
            else
            end
            deltanew1(choice)=0;
            [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltanew1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
        else            
            x=rand(1);
            if x<pPar
    %-------------------Adding/Deleting
                chi='ADdel1';
                choice=ceil(rand(1)*q);
                if choice==0
                    choice=1;
                else
                end
                deltanew1(choice) = abs(deltanew1(choice)-1);                
                [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltanew1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
            else
    %-------------------Swapping
                chi='Sdel1';
                poszeros = find(deltaprec1==0);
                posones = find(deltaprec1==1);
                choice1=ceil(rand(1)*length(poszeros));
                if choice1==0
                    choice1 = 1;
                else
                end
                choice2 = ceil(rand(1)*length(posones));
                if choice1==0
                    choice1 = 1;
                else
                end
                elem1=poszeros(choice1);
                elem2=posones(choice2);
                deltanew1(elem1)=1;            
                deltanew1(elem2)=0;                
                [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltanew1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
            end
        end
        
        logliknew = loglik -sum(B1vet(logical(gamprec)))-sum(B2vet(logical(gamprec)))+sum(B1vetnew(logical(gamprec)))+sum(B2vetnew(logical(gamprec)));
        probnew = logliknew+prigam+pridelnew1+pridel2;
        move=min(0, (probnew-probprec) );
        if move==0
            eval(['store',chi,'=[store',chi,' i];'])
            probprec = probnew;
            deltaprec1 = deltanew1;     
            DeltaSt1{i} = num2str(find(deltanew1));
            UniSt2_1(i) = length(find(deltanew1)); 
            acceptdelta1 = acceptdelta1+1;
            loglik = logliknew;
            pridel1 = pridelnew1;
            B1vet = B1vetnew; B2vet = B2vetnew;
        elseif (rand(1) < exp(move))
                eval(['store',chi,'=[store',chi,' i];'])
                probprec = probnew;
                deltaprec1 = deltanew1;     
                DeltaSt1{i} = num2str(find(deltanew1));
                UniSt2_1(i) = length(find(deltanew1)); 
                acceptdelta1 = acceptdelta1+1;
                loglik = logliknew;
                pridel1 = pridelnew1;
                B1vet = B1vetnew; B2vet = B2vetnew;
            else
                DeltaSt1{i}=num2str(find(deltaprec1));
                UniSt2_1(i)=length(find(deltaprec1));           
        end
    end

 %%%%%%% M-H step for $\delta_2$
    deltanew2 = deltaprec2; poszeros = find(deltaprec2==0); varSel =sum(gamprec);
    if isempty(poszeros)
    else        
        if length(poszeros)==q       % Forced to add variable
            chi='ADdel2';
            choice=ceil(rand(1)*q);
            if choice==0
                choice=1;
            else
            end
            deltanew2(choice) = 1;        
            [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltaprec1,deltanew2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
        elseif  isempty(poszeros)    % Forced to delete variable
            chi='ADdel2';
            choice=ceil(rand(1)*q);
            if choice==0
                choice=1;
            else
            end
            deltanew2(choice)=0;
            [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltaprec1,deltanew2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
        else            
            x=rand(1);
            if x<pPar
    %-------------------Adding/Deleting
                chi='ADdel2';
                choice=ceil(rand(1)*q);
                if choice==0
                    choice=1;
                else
                end
                deltanew2(choice) = abs(deltanew2(choice)-1); 
                [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltaprec1,deltanew2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
            else
    %-------------------Swapping
                chi='Sdel2';
                poszeros = find(deltaprec2==0);
                posones = find(deltaprec2==1);
                choice1=ceil(rand(1)*length(poszeros));
                if choice1==0
                    choice1 = 1;
                else
                end
                choice2 = ceil(rand(1)*length(posones));
                if choice1==0
                    choice1 = 1;
                else
                end
                elem1=poszeros(choice1); 
                elem2=posones(choice2); 
                deltanew2(elem1)=1;            
                deltanew2(elem2)=0;                
                [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltaprec1,deltanew2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h);
            end
        end
        
        logliknew = loglik -sum(B1vet(logical(gamprec)))-sum(B2vet(logical(gamprec)))+sum(B1vetnew(logical(gamprec)))+sum(B2vetnew(logical(gamprec)));
        probnew = logliknew+prigam+pridel1+pridelnew2;
        move=min(0, (probnew-probprec) );
        if move==0
            eval(['store',chi,'=[store',chi,' i];'])
            probprec = probnew;
            deltaprec2 = deltanew2;     
            DeltaSt2{i} = num2str(find(deltanew2));
            UniSt2_2(i) = length(find(deltanew2)); 
            acceptdelta2 = acceptdelta2+1;
            loglik = logliknew;
            pridel2 = pridelnew2;
            B1vet = B1vetnew; B2vet = B2vetnew;
        elseif (rand(1) < exp(move))
                eval(['store',chi,'=[store',chi,' i];'])
                probprec = probnew;
                deltaprec2 = deltanew2;
                DeltaSt2{i} = num2str(find(deltanew2));
                UniSt2_2(i) = length(find(deltanew2)); 
                acceptdelta2 = acceptdelta2+1;
                loglik = logliknew;
                pridel2 = pridelnew2;
                B1vet = B1vetnew; B2vet = B2vetnew;
            else
                DeltaSt2{i}=num2str(find(deltaprec2));
                UniSt2_2(i)=length(find(deltaprec2));           
        end
    end
    
%------------ Update intercepts $\mu_{01}$ and $\mu_{02}$
    varSel = sum(gamprec); varInd = find(gamprec);
    sigBeta = 0.05;
    Beta01new = Beta01prec; Beta02new = Beta02prec;
    for j=1:varSel
        NaccB = NaccB+1;
        l = varInd(j);
        % \mu_{01}
        k = 1;
        beta1Prec = Beta01prec(l);
        beta1New = beta1Prec + normrnd(0,sigBeta);
        Beta01new(l) = beta1New;
        B1vetnew = B1vet; D1vetnew = D1vet;
        [Cnew,B1vetnew,D1vetnew] = mmlfMRIbeta2(gamprec,deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Phi,Beta01new,Beta02prec...
        ,ak,bk,aj,bj,delW,l,B1vetnew,D1vetnew,k,h,h1); 
        logliknew = Cnew + sum(Avet(logical(gamprec==0))) + sum(B1vetnew(logical(gamprec))) + sum(B2vet(logical(gamprec))) +...
        sum(D1vetnew(logical(gamprec==0))) + sum(D2vet(logical(gamprec==0)));        
        if (logliknew>loglik || logliknew-loglik > log(rand(1)))
            Beta01prec(l) = beta1New;
            acceptBeta1 = acceptBeta1 + 1;
            loglik = logliknew;
            probprec = logliknew+prigam+pridel1+pridel2;
            C = Cnew; B1vet = B1vetnew; D1vet = D1vetnew;
        end
        % \mu_{02}
        k = 2;
        beta2Prec = Beta02prec(l);
        beta2New = beta2Prec + normrnd(0,sigBeta);
        Beta02new(l) = beta2New;
        B2vetnew = B2vet; D2vetnew = D2vet;
        [Cnew,B2vetnew,D2vetnew] = mmlfMRIbeta2(gamprec,deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Phi,Beta01prec,Beta02new...
        ,ak,bk,aj,bj,delW,l,B2vetnew,D2vetnew,k,h,h1);               
        logliknew = Cnew + sum(Avet(logical(gamprec==0))) + sum(B1vet(logical(gamprec))) + sum(B2vetnew(logical(gamprec))) +...
        sum(D1vet(logical(gamprec==0))) + sum(D2vetnew(logical(gamprec==0)));        
        if (logliknew>loglik || logliknew-loglik > log(rand(1))) 
                Beta02prec(l) = beta2New;
                acceptBeta2 = acceptBeta2 + 1;
                loglik = logliknew;
                probprec = logliknew+prigam+pridel1+pridel2;
                C = Cnew; B2vet = B2vetnew; D2vet = D2vetnew;
        end        
    end
ProbSt(i) = probprec;                
Beta01matSt(:,i) = Beta01prec;
Beta02matSt(:,i) = Beta02prec;
end
