function [Cnew,Bvetnew,Dvetnew] = mmlfMRIbeta2(gamprec,deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Phi,Beta01new,Beta02new...
        ,ak,bk,aj,bj,delW,l,Bvetnew,Dvetnew,k,h,h1)


varSel = sum(gamprec); PhiS = Phi(logical(gamprec),logical(gamprec)); B01pS = Beta01new(logical(gamprec)); B02pS = Beta02new(logical(gamprec));
aj_p = aj + 1/2; nSnp1 = sum(deltaprec1); nSnp2 = sum(deltaprec2);

if k==1
    ak_p1 = ak + n1/2; Zd1 = Z(Y1,logical(deltaprec1));
    Xj1 = X(Y1,l); 
    bj_p1 = bj+(Beta01new(l)^2)/2;  
    bk_p1 = bk + ((Xj1-ones(n1,1)*Beta01new(l))'*inv(1/h*eye(n1)+Zd1*Zd1')*(Xj1-ones(n1,1)*Beta01new(l)))/2;            
    Bvetnew(l) = -n1*log(sqrt(2*pi))-nSnp1/2*log(h)+ak*log(bk)-ak_p1*log(bk_p1)-gammaln(ak)+gammaln(ak_p1)- 0.5*log(det(1/h*eye(n1)+Zd1*Zd1'));               
    Dvetnew(l) = -log(sqrt(2*pi))+aj*log(bj)-aj_p*log(bj_p1)-gammaln(aj)+gammaln(aj_p);
elseif k==2
    ak_p2 = ak + n2/2; Zd2 = Z(Y2,logical(deltaprec2));
    Xj2 = X(Y2,l);
    bj_p2 = bj+(Beta02new(l)^2)/2;
    bk_p2 = bk + ((Xj2-ones(n2,1)*Beta02new(l))'*inv(1/h*eye(n2)+Zd2*Zd2')*(Xj2-ones(n2,1)*Beta02new(l)))/2;
    Bvetnew(l) = -n2*log(sqrt(2*pi))-nSnp2/2*log(h)+ak*log(bk)-ak_p2*log(bk_p2)-gammaln(ak)+gammaln(ak_p2)- 0.5*log(det(1/h*eye(n2)+Zd2*Zd2'));
    Dvetnew(l) = -log(sqrt(2*pi))+aj*log(bj)-aj_p*log(bj_p2)-gammaln(aj)+gammaln(aj_p);
end

Cnew = -varSel*log(pi)-varSel*log(h1)+(delW+varSel+1)*log(det(PhiS))+2*(gammaln((delW+varSel)/2)-2*gammaln((delW+varSel-1)/2))...
    -(delW+varSel)/2*(log(det(PhiS+(B01pS*B01pS')./h1))+log(det(PhiS+(B02pS*B02pS')./h1)));
