function [B1vetnew,B2vetnew] = mmlfMRIdelUno(deltaprec1,deltaprec2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,ak,bk,choice,h)

% ---- calculate the marginal log-likelihood
ak_p1 = ak + n1/2; ak_p2 = ak + n2/2; Zd1 = Z(Y1,logical(deltaprec1)); Zd2 = Z(Y2,logical(deltaprec2));
nSnp1 = sum(deltaprec1); nSnp2 = sum(deltaprec2);

i = choice; Xj1 = X(Y1,i); Xj2 = X(Y2,i);
bk_p1 = bk + ((Xj1-ones(n1,1)*Beta01prec(i))'*inv(1/h*eye(n1)+Zd1*Zd1')*(Xj1-ones(n1,1)*Beta01prec(i)))/2;
bk_p2 = bk + ((Xj2-ones(n2,1)*Beta02prec(i))'*inv(1/h*eye(n2)+Zd2*Zd2')*(Xj2-ones(n2,1)*Beta02prec(i)))/2;

B1vetnew = -n1*log(sqrt(2*pi))-nSnp1/2*log(h)+ak*log(bk)-ak_p1*log(bk_p1)-gammaln(ak)+gammaln(ak_p1)- 0.5*log(det(1/h*eye(n1)+Zd1*Zd1'));
B2vetnew = -n2*log(sqrt(2*pi))-nSnp2/2*log(h)+ak*log(bk)-ak_p2*log(bk_p2)-gammaln(ak)+gammaln(ak_p2)- 0.5*log(det(1/h*eye(n2)+Zd2*Zd2'));
